#include "MAXScrpt/MAXScrpt.h"
#include "MAXScrpt/3DMath.h"
#include "MAXScrpt/Name.h"
#include "MAXScrpt/MAXObj.h"
#include "MAXApi.h"
#include "INode.h"

// Declare C++ function and register it with MAXScript
#include "MAXScrpt/definsfn.h"
   def_visible_primitive(SetXRefFileName, "SetXRefFileName");
   def_visible_primitive(GetXRefFileName, "GetXRefFileName");

// ========================================================
void MxsExtendInit()
{
}

// ========================================================
Value* SetXRefFileName_cf(Value **arg_list, int count)
{
	check_arg_count_with_keys(SetXRefFileName, 2, count);

	Interface *iCore = GetCOREInterface();

	INode *root =	iCore->GetRootNode();
	int i =			arg_list[0]->to_int() - 1;

	if ( root->GetXRefFileCount() <= i || i < 0)
	{
		return &false_value;
	}

	TCHAR * str =	arg_list[1]->to_string();
	root->SetXRefFileName( i, str, false);
	
	return &ok;
}


// ========================================================
Value* GetXRefFileName_cf(Value **arg_list, int count)
{
	check_arg_count_with_keys(GetXRefFileName, 1, count);

	Interface *iCore = GetCOREInterface();

	INode *root =	iCore->GetRootNode();
	int i =			arg_list[0]->to_int() - 1;

	if ( root->GetXRefFileCount() <= i || i < 0 )
	{
		return &false_value;
	}

	TCHAR * str = root->GetXRefFileName( i );
	Value * val = Name::intern( str );
	
	return val;
}